		LIST		P=PIC16F873A
		#include	<P16F873A.INC>

		__CONFIG 	_WDT_OFF & _BODEN_OFF & _PWRTE_ON & _LVP_OFF & _HS_OSC
		ERRORLEVEL	-302


;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
; CONSTANTES:
;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#DEFINE		UU		.0
#DEFINE		DD		.1
#DEFINE		LL		.2
#DEFINE		RR		.3
#DEFINE		TL		.4
#DEFINE		TR		.5
#DEFINE		TH		.6



;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
;GPR: GENERAL PURPOSE REGISTERS
;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
;BANCO 0
;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

Aux1		EQU		0x20
Aux2		EQU		0x21
Aux3		EQU		0x22
Aux4		EQU		0x23
Aux5		EQU		0x24
DataJ1		EQU		0x25
DataJ2		EQU		0X26
DataJ3		EQU		0X27
DataJ4		EQU		0x28
DataJ5		EQU		0x29
DataJ6		EQU		0x2a
Contador	EQU		0x2b
CMD1		EQU		0x2e
CMD2		EQU		0x2f
IDJ1		EQU		0x30	;High nibble=Saturn Per ID, Low nibble = MD Per ID
IDJ2		EQU		0x31	;High nibble=Saturn Per ID, Low nibble = MD Per ID
IDJ3		EQU		0x32	;High nibble=Saturn Per ID, Low nibble = MD Per ID
IDJ4		EQU		0x33	;High nibble=Saturn Per ID, Low nibble = MD Per ID
IDJ5		EQU		0x34	;High nibble=Saturn Per ID, Low nibble = MD Per ID
IDJ6		EQU		0x35	;High nibble=Saturn Per ID, Low nibble = MD Per ID
STEPJ1		EQU		0x36
STEPJ2		EQU		0x37
STEPJ3		EQU		0x38
STEPJ4		EQU		0x39
STEPJ5		EQU		0x3A
STEPJ6		EQU		0x3B
DATA1J1		EQU		0x3C
DATA2J1		EQU		0x3D
DATA3J1		EQU		0x3E
DATA4J1		EQU		0x3F
DATA5J1		EQU		0x40
DATA1J2		EQU		0x41
DATA2J2		EQU		0x42
DATA3J2		EQU		0x43
DATA4J2		EQU		0x44
DATA5J2		EQU		0x45
DATA1J3		EQU		0x46
DATA2J3		EQU		0x47
DATA3J3		EQU		0x48
DATA4J3		EQU		0x49
DATA5J3		EQU		0x4A
DATA1J4		EQU		0x4B
DATA2J4		EQU		0x4C
DATA3J4		EQU		0x4D
DATA4J4		EQU		0x4E
DATA5J4		EQU		0x4F
DATA1J5		EQU		0x50
DATA2J5		EQU		0x51
DATA3J5		EQU		0x52
DATA4J5		EQU		0x53
DATA5J5		EQU		0x54
DATA1J6		EQU		0x55
DATA2J6		EQU		0x56
DATA3J6		EQU		0x57
DATA4J6		EQU		0x58
DATA5J6		EQU		0x59
Actualize	EQU		0x5A
TMPIDJ1		EQU		0x5B
TMPIDJ2		EQU		0x5C
TMPIDJ3		EQU		0x5D
TMPIDJ4		EQU		0x5E
TMPIDJ5		EQU		0x5F
TMPIDJ6		EQU		0x60
TMPDJX		EQU		0X61
W_TEMP		EQU		0X62
STATUS_TEMP	EQU		0X63
PCLATH_TEMP	EQU		0X64
MTAux1		EQU		0x65
MTAux2		EQU		0x66
MTAux3		EQU		0x67
ORAux1		EQU		0x68
ORAux2		EQU		0x69

;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

		ORG	0X0000

INICIO		bcf	STATUS,RP1
		bsf	STATUS,RP0
		MOVLW	0x06 		;PINS DEL PUERTO A TODOS DIGITALES.
		MOVWF	ADCON1
		movlw	0x01		;set PORTA,0 as input(1) because a switch is connected to it
		movwf	TRISA
		movlw	b'01100000'	;bit6= TH(I) bit5= TR(I) bit4= TL(O) bit3= R(O) bit2= L(O) bit1= D(O) bit0= U(O)
		movwf	TRISB
		movlw	b'00011111'
		movwf	TRISC
		bcf	STATUS,RP0
		clrf	PORTA
		movlw	b'00010001'
		movwf	PORTB		;Initialize Mutipad as Step0.

Wait00		movlw	b'01100000'
		andwf	PORTB,W
		btfss	STATUS,Z	;Ready to init data transmition?
		goto	Wait00		;No,so wait...

		call	SendMTData	;yes, so...go!

		incf	PORTA,F
		goto	Wait00





;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


SendMTData						;View Multitap Protococol Image to follow this algorithm
Step3	
		call	ClearRLDU
		bcf	PORTB,TL			;Send X000 0000

Step3Mid4
		btfss	PORTB,TR
		goto	$-1				;Wait to SS send 01
Step4	
		bsf	PORTB,UU			;Prepare Pins Before Set TL pin
		bsf	PORTB,TL			;Send X011 0001	(Multitap ID=1)

Step4Mid5
		btfsc	PORTB,TR
		goto	$-1				;Wait to SS send 00

Step5
		call	ClearRLDU
		movlw	0x06				;send 6 TAPS
		iorwf	PORTB,F				;Prepare Pins Before Clear TL pin
		bcf	PORTB,TL			;Send 0000 0110

Step5Mid6
		btfss	PORTB,TR
		goto	$-1				;Wait to SS send 01

Step6
		call	ClearRLDU
		bsf	PORTB,TL			;Send 0011 0000

Step6Mid7
		btfsc	PORTB,TR
		goto	$-1				;Wait to SS send 00

Step7							;Here Data on PORTB is: 0001 0000

;Channel 1:

		call	ClearRLDU
		movlw	0x00
		iorwf	PORTB,F			;Put Channel 1 ID on RLDU pins
		bcf	PORTB,TL
		btfss	PORTB,TR
		goto	$-1			;Wait until SS set TR as high(goto $-1 = goto previous instruction)

		call	ClearRLDU
		movlw	0x02
		iorwf	PORTB,F			;Put Channel 1 Data Size
		bsf	PORTB,TL
		btfsc	PORTB,TR
		goto	$-1		

		call	ClearRLDU
		movlw	0x0F
		iorwf	PORTB,F			
		btfss	PORTA,0			;I put a switch on PORTA,0 of the PIC, so if its pressed, it will send Right button as pressed
		bcf	PORTB,RR		;set Right button as pressed

		bcf	PORTB,TL		;Send Right Left Down Up
		btfss	PORTB,TR
		goto	$-1

		call	ClearRLDU	
		movlw	0x0F			
		iorwf	PORTB,F
		bsf	PORTB,TL		;Send START A C B
		btfsc	PORTB,TR
		goto	$-1

		call	ClearRLDU
		movlw	0x0F
		iorwf	PORTB,F		
		bcf	PORTB,TL		;Send  R X Y Z 
		btfss	PORTB,TR
		goto	$-1

		call	ClearRLDU	
		movlw	0x0F
		iorwf	PORTB,F
		bsf	PORTB,TL		;send L 1 1 1
		btfsc	PORTB,TR
		goto	$-1



;Channel 2:

		call	ClearRLDU
		movlw	0x0F
		iorwf	PORTB,F		;Put Peripheric 2 ID on RLDU pins
		bcf	PORTB,TL
		btfss	PORTB,TR
		goto	$-1

		call	ClearRLDU
		movlw	0x0F
		iorwf	PORTB,F		;Put Peripheric 2 Data Size
		bsf	PORTB,TL
		btfsc	PORTB,TR
		goto	$-1		

;Channel 3:

		call	ClearRLDU
		movlw	0x0F
		iorwf	PORTB,F		;Put Peripheric 3 ID on RLDU pins
		bcf	PORTB,TL
		btfss	PORTB,TR
		goto	$-1

		call	ClearRLDU
		movlw	0x0F
		iorwf	PORTB,F		;Put Peripheric 3 Data Size
		bsf	PORTB,TL
		btfsc	PORTB,TR
		goto	$-1		

;Channel 4:


		call	ClearRLDU
		movlw	0x0F
		iorwf	PORTB,F		;Put Peripheric 4 ID on RLDU pins
		bcf	PORTB,TL
		btfss	PORTB,TR
		goto	$-1

		call	ClearRLDU
		movlw	0x0F
		iorwf	PORTB,F		;Put Peripheric 4 Data Size
		bsf	PORTB,TL
		btfsc	PORTB,TR
		goto	$-1		

;Channel 5:


		call	ClearRLDU
		movlw	0x0F
		iorwf	PORTB,F		;Put Peripheric 5 ID on RLDU pins
		bcf	PORTB,TL
		btfss	PORTB,TR
		goto	$-1

		call	ClearRLDU
		movlw	0x0F
		iorwf	PORTB,F		;Put Peripheric 5 Data Size
		bsf	PORTB,TL
		btfsc	PORTB,TR
		goto	$-1		

;Channel 6:

		call	ClearRLDU
		movlw	0x0F
		iorwf	PORTB,F		;Put Peripheric 6 ID on RLDU pins
		bcf	PORTB,TL
		btfss	PORTB,TR
		goto	$-1

		call	ClearRLDU
		movlw	0x0F
		iorwf	PORTB,F		;Put Peripheric 6 Data Size
		bsf	PORTB,TL

StepNthData
		btfsc	PORTB,TR
		goto	$-1

		call	ClearRLDU
		bcf	PORTB,TL		;Send 0000 0000 (Sending this step as "0000" seems to be DATA CONFIRMED")
		
StepNthDataMidNthDataPlus1			;StepNthDataMidNthData+1
		btfss	PORTB,TR
		goto	$-1			;Wait to SS to send 01

NthDataPlus1
		bsf	PORTB,UU		;Put 0010 0001 on PORTB
		bsf	PORTB,TL		;Send 0011 0001 to SS

StepEnd
		btfss	PORTB,TH
		goto	$-1			;Wait to SS to send 11

		return				;All sended! Return

;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

ClearRLDU					;Cleans RLDU pins to include disaire data later WITHOUT AFFECTING TL PIN
		movlw	0xF0
		andwf	PORTB,F			;Force to zero the low nibble	
		return

;////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

		END
